CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  _irrpin       = 12     'ir receiver module on this pin
  _device       = 0     'accept any device code
        
  _dlyrpt       = 6     'delay before acception code as repeat

VAR
  byte displayRAM[1024]  
  byte vcStack[130]
  byte vcStack2[130] 
  long drQueTable[200]
  byte bCog
  byte dSize
  
OBJ
  CMD_P : "LockPool"
  LCD : "LCD_DRIV"
  CMD_Q : "LockQueue" 
  IR : "ir_reader_sony"
PUB start |   keycode
  dSize := 16
  LCD.init
  LCD.pos(1,1)
  LCD.writestr(string("Starting IR port...",LCD#eos))
  IR.init(_irrpin,_device,_dlyrpt,true)                 'startup
  LCD.pos(2,1)
  LCD.writestr(string("Init Mem. Man...",LCD#eos)) 
  CMD_P.Initialize(@displayRAM,1024,128,4)
  CMD_Q.Initialize(@drQueTable,200)                      ' creates the queue for storing addresse of pooled strings   
  'cognew(LoadBuffer(@COG_RUN,@dSize),@vcStack)
  'GetVincuBuffer
  LCD.pos(3,1)

  LCD.cll
  LCD.pos(1,1)
  LCD.writestr(string("Dynamic Memory Test",LCD#eos))
  repeat
    keycode := IR.fifo_get   'try a get from fifo
    if keycode == -1
      LCD.pos(2,1)
      LCD.writestr(string("QCnt :",LCD#eos))
      LCD.hex(CMD_Q.count,3)
      LCD.writeout(LCD#space)
      LCD.writestr(string(" PTtl:",LCD#eos))
      LCD.hex(CMD_P.GetMaxFree,4)
      LCD.pos(3,1)
      LCD.writestr(string("Used :",LCD#eos))
      LCD.hex(CMD_P.GetTotalUsed,4)
      LCD.writeout(LCD#space)
      LCD.writestr(string("Free:",LCD#eos))
      LCD.hex(CMD_P.FindMaxFree,4)
      
      LCD.pos(4,1)
      LCD.writestr(string("DatSz:",LCD#eos))
      LCD.hex(dSize,2)
      'LCD.writestr(string(" ",LCD#eos))
      'LCD.hex(COG_RUN,2)
      if COG_RUN > 0
        LCD.pos(4,20)
        LCD.writeout($FC)
      else
        
        LCD.pos(4,20)
        LCD.writeout($20)
        'LCD.writeout($20)
        'LCD.writeout($20)
        '  
        if CMD_P.FindMaxFree < dSize+1 and COG_RUN<1
          waitcnt(clkfreq *3 + cnt)
          COG_RUN := 0
          cognew(Clearbuffer(@COG_RUN),@vcStack)
          'LCD.pos(4,1)
        'LCD.hex(PopBuffer,8)
    else
      case keycode
        IR#btnPower :     ' powerBtn
          lcd.cls
          lcd.writestr(@RB)
          reboot
        IR#btnPlay:
          if COG_RUN == 0
            cognew(LoadBuffer(@COG_RUN,@dSize),@vcStack)
        IR#btn2x:
          dSize>>=1
        IR#btnSlow:
          if dSize == 0
            dSize:=1
          else
            dSize <<=1
        OTHER:
          lcd.pos(4,15)
          lcd.hex(keycode,4)
      
  ' waitcnt(clkfreq/10  + cnt)

PUB PopBuffer | t,q,size

  'size :=4
  
  t:= CMD_Q.Pop
  result:=t
  if not t==$FFFFFFFF
    CMD_P.Free(t)
      
PUB ClearBuffer(addCogRun) | t,q,size
  byte[addCogRun] += 1
  'size :=4
  repeat
    t:= CMD_Q.Pop
    if not t==$FFFFFFFF
      CMD_P.Free(t)
      waitcnt(clkfreq/5 + cnt)
    else
      byte[addCogRun] -= 1
      cogstop(cogid)
    
PUB LoadBuffer(addCogRun,addSize) | t,q,size
  byte[addCogRun] += 1
  
  
  
  repeat
    size:= byte[addSize]
    if CMD_P.FindMaxFree > size
      t :=  CMD_P.Alloc(size)
      if not t == $FFFFFFFF
        q := CMD_Q.Push(t)
        if q == 0
          byte[addCogRun] -=1
          cogstop(cogid)
      else
        byte[addCogRun] -= 1
        cogstop(cogid)
        
    else
      byte[addCogRun] -= 1
      cogstop(cogid)
    waitcnt(clkfreq/5 + cnt)

DAT
        COG_RUN byte 0
        RB byte "Rebooting...",LCD#eos  